with Names;

package AocsMgr is

   use Names;

   type Controller_T is (
      None,
      Coarse_Pointing_Control,
      Fine_Pointing_Control,
      Virtual );

   type Controller_Status_T is (
      Idle,
      Preparing,
      Ready,
      Running );


   type Control_Algorithm_T is record

      Current : Controller_T;

      Status : Controller_Status_T;

      Timer : Natural;

      PLI_Enabled : Boolean;

      PLI_Timer : Natural;

      Error : Error_ID_T;

   end record;


   Control_Law : Control_Algorithm_T := (
      --
      Current => None,
      Status  => Idle,
      Timer   => 0,
      --
      PLI_Enabled => False,
      PLI_Timer   => 0,
      --
      Error => None );


   procedure Main;

   procedure Stop_PLI_Management;

   procedure Start_PLI_Management;

   function PLI_Is_Ready return Boolean;

   procedure Select_Controller (Algo : Controller_T);

   procedure Prepare_Controller;

   function Controller_Is_Ready return Boolean;

   procedure Start_Controller;

   function Coarse_Pointing_Reached return Boolean;

   function Fine_Pointing_Reached return Boolean;

end AocsMgr;
