with Names;
with AocsMgr;
with UnitMgr;

package body ModeMgr.Transitions is

   use Names;

   Trans : Transition_T renames ModeMgr.Trans;

   procedure To_StandbyMode is
      -- Invariant: ModeMgr.Mode = Off
      Ret_Value_from_Call : Boolean;
   begin

-- ModeMgr.Main execution statement   76
      case Trans.Step is

         when 0 =>

-- ModeMgr.Main execution statement   77
            AocsMgr.Select_Controller (AocsMgr.None);

-- ModeMgr.Main execution statement  577
            UnitMgr.Release_All;

-- ModeMgr.Main execution statement  601
            Trans.Step := Trans.Step + 1;

         when 1 =>

-- ModeMgr.Main execution statement  602
            Ret_Value_from_Call := UnitMgr.All_Off;
-- ModeMgr.Main execution statement  618
            if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  619
               ModeMgr.Separation_StartCheck;

-- ModeMgr.Main execution statement  622
               Trans.Done := True;

            end if;

         when others =>

            null;

      end case;

   end To_StandbyMode;

   procedure To_SafeMode is
      -- Invariant: ModeMgr.Separation_Done
      Ret_Value_from_Call : Boolean;
   begin

-- ModeMgr.Main execution statement   80
      case Trans.Step is

         when 0 =>

-- ModeMgr.Main execution statement   81
            AocsMgr.Select_Controller (AocsMgr.Virtual);

-- ModeMgr.Main execution statement   86
            AocsMgr.Stop_PLI_Management;

-- ModeMgr.Main execution statement   88
            UnitMgr.Release_All;

-- ModeMgr.Main execution statement  112
            Trans.Step := Trans.Step + 1;


         when 1 =>

-- ModeMgr.Main execution statement  113
            Ret_Value_from_Call := UnitMgr.All_Off;
-- ModeMgr.Main execution statement  129
            if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  130
               UnitMgr.Start_Mode_Specific_Unit_Conf (Safe);

-- ModeMgr.Main execution statement  176
               Trans.Step := Trans.Step + 1;

            end if;


         when 2 =>

-- ModeMgr.Main execution statement  177
            Ret_Value_from_Call := UnitMgr.Unit_Conf_Done (Mode => Safe);
-- ModeMgr.Main execution statement  192
            if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  193
               AocsMgr.Select_Controller (AocsMgr.Coarse_Pointing_Control);

-- ModeMgr.Main execution statement  198
               AocsMgr.Prepare_Controller;

-- ModeMgr.Main execution statement  201
               Trans.Step := Trans.Step + 1;

            end if;

         when 3 =>

-- ModeMgr.Main execution statement  202
            Ret_Value_from_Call := AocsMgr.Controller_Is_Ready;
-- ModeMgr.Main execution statement  205
            if Ret_Value_from_Call then
-- ModeMgr.Main execution statement  206
               Ret_Value_from_Call := UnitMgr.No_Reconfiguration;
-- ModeMgr.Main execution statement  213
               if Ret_Value_from_Call then
                  -- We should not lock units which are under
                  -- reconfiguration!!

-- ModeMgr.Main execution statement  214
                  AocsMgr.Start_Controller;

-- ModeMgr.Main execution statement  217
                  UnitMgr.Lock_All_Selected (Mode => Safe);

-- ModeMgr.Main execution statement  222
                  Trans.Done := True;

               end if;
            end if;

         when others =>

            null;

      end case;

   end To_SafeMode;


   procedure To_NominalMode is
      Ret_Value_from_Call : Boolean;
   begin

-- ModeMgr.Main execution statement  225
      case Trans.Step is

         when 0 =>

-- ModeMgr.Main execution statement  226
            AocsMgr.Select_Controller (AocsMgr.Virtual);

-- ModeMgr.Main execution statement  231
            AocsMgr.Stop_PLI_Management;

-- ModeMgr.Main execution statement  233
            UnitMgr.Start_Mode_Specific_Unit_Conf (Nominal);

-- ModeMgr.Main execution statement  279
            Trans.Step := Trans.Step + 1;

         when 1 =>

-- ModeMgr.Main execution statement  280
            Ret_Value_from_Call := UnitMgr.Unit_Conf_Done (Mode => Nominal);
-- ModeMgr.Main execution statement  295
            if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  296
               AocsMgr.Select_Controller (AocsMgr.Fine_Pointing_Control);

-- ModeMgr.Main execution statement  301
               AocsMgr.Prepare_Controller;

-- ModeMgr.Main execution statement  304
               Trans.Step := Trans.Step + 1;

            end if;

         when 2 =>

-- ModeMgr.Main execution statement  305
            Ret_Value_from_Call := AocsMgr.Controller_Is_Ready;
-- ModeMgr.Main execution statement  308
            if Ret_Value_from_Call then
-- ModeMgr.Main execution statement  309
               Ret_Value_from_Call := UnitMgr.No_Reconfiguration;
-- ModeMgr.Main execution statement  316
               if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  317
                  AocsMgr.Start_Controller;

-- ModeMgr.Main execution statement  320
                  UnitMgr.Lock_All_Selected (Mode => Nominal);

-- ModeMgr.Main execution statement  325
                  Trans.Done := True;

               end if;
            end if;

         when others =>

            null;

      end case;

   end To_NominalMode;


   procedure To_PrepMode is
      Ret_Value_from_Call : Boolean;
   begin

-- ModeMgr.Main execution statement  422
      case Trans.Step is

         when 0 =>

-- ModeMgr.Main execution statement  423
            AocsMgr.Stop_PLI_Management;

-- ModeMgr.Main execution statement  425
            Trans.Step := Trans.Step + 1;

         when 1 =>

-- ModeMgr.Main execution statement  426
            Ret_Value_from_Call := UnitMgr.No_Reconfiguration;
-- ModeMgr.Main execution statement  433
            if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  434
               Ret_Value_from_Call := UnitMgr.State_by_U_Is (
                  GPS, GPS_Coarse_Navigation);
-- ModeMgr.Main execution statement  445
               if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  446
                  UnitMgr.Start_Transition_U (GPS, GPS_Fine_Navigation);

               end if;

-- ModeMgr.Main execution statement  467
               UnitMgr.Start_Transition_U (PLI, PLI_Standby);

-- ModeMgr.Main execution statement  488
               Trans.Step := Trans.Step + 1;

            end if;

         when 2 =>

-- ModeMgr.Main execution statement  489
            Ret_Value_from_Call := UnitMgr.State_by_U_Is (
               GPS, GPS_Fine_Navigation);
-- ModeMgr.Main execution statement  500
            if Ret_Value_from_Call then
-- ModeMgr.Main execution statement  501
               Ret_Value_from_Call := UnitMgr.State_by_U_Is (
                  PLI, PLI_Standby);
-- ModeMgr.Main execution statement  512
               if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  513
                  UnitMgr.Lock (PLI);

-- ModeMgr.Main execution statement  515
                  AocsMgr.Start_PLI_Management;

-- ModeMgr.Main execution statement  518
                  Trans.Done := True;

               end if;
            end if;

         when others =>

            null;

      end case;

   end To_PrepMode;


   procedure To_ScienceMode is
      Ret_Value_from_Call : Boolean;
   begin

-- ModeMgr.Main execution statement  520
      case Trans.Step is

         when 0 =>

-- ModeMgr.Main execution statement  521
            UnitMgr.Start_Transition_U (PLI, PLI_Science);

-- ModeMgr.Main execution statement  542
            Trans.Step := Trans.Step + 1;

         when 1 =>

-- ModeMgr.Main execution statement  543
            Ret_Value_from_Call := UnitMgr.State_by_U_Is (
               PLI, PLI_Science);
-- ModeMgr.Main execution statement  554
            if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  555
               Trans.Done := True;

            end if;

         when others =>

            null;

      end case;

   end To_ScienceMode;


   procedure Back_To_Nominal is
      Ret_Value_from_Call : Boolean;
   begin

-- ModeMgr.Main execution statement  328
      case Trans.Step is

         when 0 =>

-- ModeMgr.Main execution statement  329
            AocsMgr.Stop_PLI_Management;

-- ModeMgr.Main execution statement  331
            UnitMgr.Release (PLI);

-- ModeMgr.Main execution statement  353
            Trans.Step := Trans.Step + 1;

         when 1 =>

-- ModeMgr.Main execution statement  354
            Ret_Value_from_Call := UnitMgr.No_Reconfiguration;
-- ModeMgr.Main execution statement  361
            if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  362
               Ret_Value_from_Call := UnitMgr.State_by_U_Is (
                  GPS, GPS_Fine_Navigation);
-- ModeMgr.Main execution statement  373
               if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  374
                  UnitMgr.Start_Transition_U (GPS, GPS_Coarse_Navigation);

               end if;

-- ModeMgr.Main execution statement  395
               Trans.Step := Trans.Step + 1;

            end if;

         when 2 =>

-- ModeMgr.Main execution statement  396
            Ret_Value_from_Call := UnitMgr.State_by_U_Is (PLI, Off);
-- ModeMgr.Main execution statement  407
            if Ret_Value_from_Call then
-- ModeMgr.Main execution statement  408
               Ret_Value_from_Call := UnitMgr.State_by_U_Is (
                  GPS, GPS_Coarse_Navigation);
-- ModeMgr.Main execution statement  419
               if Ret_Value_from_Call then

-- ModeMgr.Main execution statement  420
                  Trans.Done := True;

               end if;
            end if;

         when others =>

            null;

      end case;

   end Back_To_Nominal;


end ModeMgr.Transitions;
