with Ada.Text_IO;

with Names;
with HW_Simulation;


package body UnitMgr.Branch_Control is

   use Names;

   procedure Init_Transition (
      UnId : Unit_ID_T;
      BrId : Branch_ID_T ) is
   begin
-- ModeMgr.Main execution statement   69
-- ModeMgr.Main execution statement  108
-- ModeMgr.Main execution statement  150
-- ModeMgr.Main execution statement  172
-- ModeMgr.Main execution statement  253
-- ModeMgr.Main execution statement  275
-- ModeMgr.Main execution statement  349
-- ModeMgr.Main execution statement  391
-- ModeMgr.Main execution statement  463
-- ModeMgr.Main execution statement  484
-- ModeMgr.Main execution statement  538
-- ModeMgr.Main execution statement  597
-- UnitMgr.Main execution statement   10
-- UnitMgr.Main execution statement   22
-- UnitMgr.Main execution statement   80
-- UnitMgr.Main execution statement   88
      Units(UnId).Br(BrId).Target_State := None;
-- ModeMgr.Main execution statement   70
-- ModeMgr.Main execution statement  109
-- ModeMgr.Main execution statement  151
-- ModeMgr.Main execution statement  173
-- ModeMgr.Main execution statement  254
-- ModeMgr.Main execution statement  276
-- ModeMgr.Main execution statement  350
-- ModeMgr.Main execution statement  392
-- ModeMgr.Main execution statement  464
-- ModeMgr.Main execution statement  485
-- ModeMgr.Main execution statement  539
-- ModeMgr.Main execution statement  598
-- UnitMgr.Main execution statement   11
-- UnitMgr.Main execution statement   23
-- UnitMgr.Main execution statement   81
-- UnitMgr.Main execution statement   89
      Units(UnId).Br(BrId).Step := 0;
-- ModeMgr.Main execution statement   71
-- ModeMgr.Main execution statement  110
-- ModeMgr.Main execution statement  152
-- ModeMgr.Main execution statement  174
-- ModeMgr.Main execution statement  255
-- ModeMgr.Main execution statement  277
-- ModeMgr.Main execution statement  351
-- ModeMgr.Main execution statement  393
-- ModeMgr.Main execution statement  465
-- ModeMgr.Main execution statement  486
-- ModeMgr.Main execution statement  540
-- ModeMgr.Main execution statement  599
-- UnitMgr.Main execution statement   12
-- UnitMgr.Main execution statement   24
-- UnitMgr.Main execution statement   82
-- UnitMgr.Main execution statement   90
      Units(UnId).Br(BrId).Timer := 0;
   end Init_Transition;

   procedure Possible_State_Transition_Step (
      UnId : Unit_ID_T;
      BrId : Branch_ID_T )
   is
      Prev_Step : Natural;
      Ret_Value_from_Call : Boolean;
   begin
-- UnitMgr.Main execution statement   34
      if Units(UnId).Br(BrId).Target_State /= None then
         -- Transition to new operational state is ongoing
-- UnitMgr.Main execution statement   35
         Prev_Step := Units(UnId).Br(BrId).Step;
         Ada.Text_IO.Put_Line ("br="&UnId'Img & " " & BrId'Img
            & " stp=" & Units(UnId).Br(BrId).Step'Img
            & " st=" & Units(UnId).Br(BrId).State'Img
            & " tst=" & Units(UnId).Br(BrId).Target_State'Img);
-- UnitMgr.Main execution statement   36
         if Units(UnId).Br(BrId).Target_State = Off
            or Units(UnId).Br(BrId).State = Off
         then
-- UnitMgr.Main execution statement   37
            if Units(UnId).Br(BrId).Step = 0 then
-- UnitMgr.Main execution statement   38
               HW_Simulation.Receive_HW_Signals (UnId, BrId,
                  Units(UnId).Br(BrId).Target_State = Off);
-- UnitMgr.Main execution statement   45
               Units(UnId).Br(BrId).Step := 1;
-- UnitMgr.Main execution statement   46
            elsif Units(UnId).Br(BrId).Target_State = Off then
-- UnitMgr.Main execution statement   47
               if Units(UnId).Br(BrId).Timer >= 3 then
                  -- Unconditionally declare the unit to be in Off state
                  -- after 3 cycles, no check of the real sending or effect
                  -- of the H/W signals
-- UnitMgr.Main execution statement   48
                  Units(UnId).Br(BrId).State := Off;
               end if;
            else
-- UnitMgr.Main execution statement   49
               Ret_Value_from_Call := HW_Simulation.Powered (UnId, BrId);
-- UnitMgr.Main execution statement   54
               if Ret_Value_from_Call then
-- UnitMgr.Main execution statement   55
                  Units(UnId).Br(BrId).State := Least_Non_Off_State(UnId);
-- UnitMgr.Main execution statement   56
                  if Units(UnId).Br(BrId).State /=
                     Units(UnId).Br(BrId).Target_State
                  then
-- UnitMgr.Main execution statement   57
                     Units(UnId).Br(BrId).Step := 2;
                  end if;
               end if;
            end if;
-- UnitMgr.Main execution statement   58
         elsif UnId = GPS or UnId = PLI then
-- UnitMgr.Main execution statement   59
            if Units(UnId).Br(BrId).Step = 0
               or Units(UnId).Br(BrId).Step = 2
            then 
-- UnitMgr.Main execution statement   60
               if Units(UnId).Br(BrId).Step = 0
                  and Units(UnId).Br(BrId).State = Least_Non_Off_State(UnId)
               then
-- UnitMgr.Main execution statement   61
                  Units(UnId).Br(BrId).Step := 2;
               end if;
-- UnitMgr.Main execution statement   62
               HW_Simulation.Receive_TC (UnId, BrId,
                  Target_State_TC(Units(UnId).Br(BrId).Target_State));
-- UnitMgr.Main execution statement   70
               Units(UnId).Br(BrId).Step := Units(UnId).Br(BrId).Step + 1;
            else
-- UnitMgr.Main execution statement   71
               Ret_Value_from_Call := HW_Simulation.Event_Generated (
                  UnId, BrId,
                  Target_State_Event(Units(UnId).Br(BrId).Target_State));
-- UnitMgr.Main execution statement   76
               if Ret_Value_from_Call then
-- UnitMgr.Main execution statement   77
                  Units(UnId).Br(BrId).State := Units(UnId).Br(BrId).Target_State;
               end if;
            end if;
         end if;
-- UnitMgr.Main execution statement   78
         if Units(UnId).Br(BrId).State = Units(UnId).Br(BrId).Target_State then
            -- Transition to new operational state is over
-- UnitMgr.Main execution statement   79
            Init_Transition (UnId, BrId);
-- UnitMgr.Main execution statement   83
         elsif Prev_Step < Units(UnId).Br(BrId).Step then
            -- One step handled
-- UnitMgr.Main execution statement   84
            Units(UnId).Br(BrId).Timer := 0;
         else
-- UnitMgr.Main execution statement   85
            Units(UnId).Br(BrId).Timer := Units(UnId).Br(BrId).Timer + 1;
-- UnitMgr.Main execution statement   86
            if Units(UnId).Br(BrId).Timer > Units(UnId).Br(BrId).Timeout_Limit then
-- UnitMgr.Main execution statement   87
               Init_Transition (UnId, BrId);
-- UnitMgr.Main execution statement   91
               Units(UnId).Br(BrId).Error := Timeout;
               Ada.Text_IO.Put_Line ("utimeo br="&UnId'Img & " " & BrId'Img);
            end if;
         end if;
      end if;
   end Possible_State_Transition_Step;

end UnitMgr.Branch_Control;
